<?php

namespace Drupal\cl_selector_field\Plugin\Field\FieldFormatter;

use Drupal\cl_selector_field\Plugin\Field\FieldType\StyleSelectorItem;
use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\FormatterBase;

/**
 * Plugin implementation of the 'cl_selector_field_style_selector_table' formatter.
 *
 * @FieldFormatter(
 *   id = "cl_selector_field_style_selector_table",
 *   label = @Translation("Table"),
 *   field_types = {"cl_selector_field_style_selector"}
 * )
 */
class StyleSelectorTableFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $header[] = '#';
    $header[] = $this->t('Component');
    $header[] = $this->t('Variant');

    $table = [
      '#type' => 'table',
      '#header' => $header,
    ];

    foreach ($items as $delta => $item) {
      if (!$item instanceof StyleSelectorItem) {
        continue;
      }
      $row = [];

      $row[]['#markup'] = $delta + 1;

      if ($item->component) {
        $allowed_values = $item->allowedComponentValues();
        $row[]['#markup'] = $allowed_values[$item->component];
      }
      else {
        $row[]['#markup'] = '';
      }
      $row[]['#markup'] = $item->variant ?? '';

      $table[$delta] = $row;
    }

    return [$table];
  }

}
